package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkOrderToSapService;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderToSap;
import cn.estsh.i3plus.pojo.mes.model.MesWorkOrderModel;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.*;
import java.util.stream.Collectors;

@Service
@Slf4j
public class MesWorkOrderToSapServiceImpl extends BaseMesService<MesWorkOrderToSap> implements IMesWorkOrderToSapService {

    @Override
    public MesWorkOrderToSap insert(MesWorkOrderModel mesWorkOrder) {
        MesWorkOrderToSap mesWorkOrderToSap = new MesWorkOrderToSap(mesWorkOrder.getOrganizeCode(),
                mesWorkOrder.getOrganizeCode(), mesWorkOrder.getPartNo(), mesWorkOrder.getProductVersion(),
                mesWorkOrder.getQty(), mesWorkOrder.getPlanStartTime());
        ConvertBean.serviceModelUpdate(mesWorkOrderToSap,mesWorkOrder.getModifyUser());
        return baseRDao.insert(mesWorkOrderToSap);
    }

    @Override
    public void doMesWorkOrder(String organizeCode,String userName,List<MesWorkOrderModel> mesWorkOrderList) {
        //查询表里原有数据
        Map<String, MesWorkOrderToSap> workOrderToSapMap = getStringMesWorkOrderToSapMap(organizeCode, mesWorkOrderList);
        //数据处理
        for (MesWorkOrderModel mesWorkOrder : mesWorkOrderList) {
            String key = new StringJoiner(MesExtConstWords.COMMA).add(mesWorkOrder.getPartNo()).add(mesWorkOrder.getPlanStartTime()).toString();
            mesWorkOrder.setModifyUser(userName);
            //计划开始时间+物料查询发送Sap的数据
            if(!workOrderToSapMap.containsKey(key)){
                insert(mesWorkOrder);
            }else{
                if(!Objects.equals(workOrderToSapMap.get(key).getGsmng(),mesWorkOrder.getQty())){
                    insert(mesWorkOrder);
                }
            }
        }
    }

    private Map<String, MesWorkOrderToSap> getStringMesWorkOrderToSapMap(String organizeCode, List<MesWorkOrderModel> mesWorkOrderList) {
        List<String> partNoList = mesWorkOrderList.stream().map(MesWorkOrderModel::getPartNo).distinct().collect(Collectors.toList());
        List<String> planStartTime = mesWorkOrderList.stream().map(MesWorkOrderModel::getPlanStartTime).distinct().collect(Collectors.toList());
        DdlPackBean ddlPackBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(planStartTime,"pedtr",ddlPackBean);
        DdlPreparedPack.getInPackList(partNoList,"plmat",ddlPackBean);
        ddlPackBean.setOrderByStr(" order by createDatetime desc ");
        List<MesWorkOrderToSap> workOrderToSapList = baseRDao.findByHqlWhere(ddlPackBean);
        Map<String,MesWorkOrderToSap> workOrderToSapMap = new HashMap<>();
        if(!CollectionUtils.isEmpty(workOrderToSapList)){
            for (MesWorkOrderToSap mesWorkOrderToSap : workOrderToSapList) {
                String key = new StringJoiner(MesExtConstWords.COMMA).add(mesWorkOrderToSap.getPlmat()).add(mesWorkOrderToSap.getPedtr()).toString();
                if(!workOrderToSapMap.containsKey(key)){
                    workOrderToSapMap.put(key,mesWorkOrderToSap);
                }
            }
        }
        return workOrderToSapMap;
    }
}
